Change various example paths in the config files to match SUSE.

Index: xen-4.1.4-testing/tools/examples/xmexample1
===================================================================
--- xen-4.1.4-testing.orig/tools/examples/xmexample1
+++ xen-4.1.4-testing/tools/examples/xmexample1
@@ -7,11 +7,17 @@
 #============================================================================
 
 #----------------------------------------------------------------------------
-# Kernel image file.
-kernel = "/boot/vmlinuz-2.6.10-xenU"
-
-# Optional ramdisk.
-#ramdisk = "/boot/initrd.gz"
+# Kernel image file and (optional) ramdisk (initrd).
+kernel = "/boot/vmlinuz-xen"
+ramdisk = "/boot/initrd-xen"
+
+# Or use a bootloader instead of kernel/ramdisk to get the kernel from domU FS
+# domUloader bootloader example:
+#bootloader = "/usr/lib/xen/boot/domUloader.py"
+#bootentry = "hda2:/vmlinuz-xen,/initrd-xen"
+# pygrub bootloader example:
+#bootloader="/usr/bin/pygrub"
+#bootargs=""
 
 # The domain build function. Default is 'linux'.
 #builder='linux'
@@ -49,11 +55,11 @@ name = "ExampleDomain"
 #
 # or optionally override backend, bridge, ip, mac, script, type, or vifname:
 #
-# vif = [ 'mac=00:16:3e:00:00:11, bridge=xenbr0' ]
+# vif = [ 'mac=00:16:3e:00:00:11, bridge=br0' ]
 #
 # or more than one interface may be configured:
 #
-# vif = [ '', 'bridge=xenbr1' ]
+# vif = [ '', 'bridge=br1' ]
 
 vif = [ '' ]
 
@@ -131,7 +137,7 @@ disk = [ 'phy:hda1,hda1,w' ]
 #hostname= "vm%d" % vmid
 
 # Set root device.
-root = "/dev/hda1 ro"
+root = "/dev/hda1"
 
 # Root device for nfs.
 #root = "/dev/nfs"
@@ -140,8 +146,8 @@ root = "/dev/hda1 ro"
 # Root directory on the nfs server.
 #nfs_root   = '/full/path/to/root/directory'
 
-# Sets runlevel 4.
-extra = "4"
+# Extra arguments to pass to the kernel.
+extra = ""
 
 #----------------------------------------------------------------------------
 # Configure the behaviour when a domain exits.  There are three 'reasons'
Index: xen-4.1.4-testing/tools/examples/xmexample2
===================================================================
--- xen-4.1.4-testing.orig/tools/examples/xmexample2
+++ xen-4.1.4-testing/tools/examples/xmexample2
@@ -35,11 +35,17 @@ xm_vars.var('vmid',
 xm_vars.check()
 
 #----------------------------------------------------------------------------
-# Kernel image file.
-kernel = "/boot/vmlinuz-2.6.10-xenU"
-
-# Optional ramdisk.
-#ramdisk = "/boot/initrd.gz"
+# Kernel image file and (optional) ramdisk (initrd).
+kernel = "/boot/vmlinuz-xen"
+ramdisk = "/boot/initrd-xen"
+
+# Or use a bootloader instead of kernel/ramdisk to get the kernel from domU FS
+# domUloader bootloader example:
+#bootloader = "/usr/lib/xen/boot/domUloader.py"
+#bootentry = "hda2:/vmlinuz-xen,/initrd-xen"
+# pygrub bootloader example:
+#bootloader="/usr/bin/pygrub"
+#bootargs=""
 
 # The domain build function. Default is 'linux'.
 #builder='linux'
@@ -80,11 +86,11 @@ vcpus = 4 # make your domain a 4-way
 #
 # or optionally override backend, bridge, ip, mac, script, type, or vifname:
 #
-# vif = [ 'mac=00:16:3e:00:00:11, bridge=xenbr0' ]
+# vif = [ 'mac=00:16:3e:00:00:11, bridge=br0' ]
 #
 # or more than one interface may be configured:
 #
-# vif = [ '', 'bridge=xenbr1' ]
+# vif = [ '', 'bridge=br1' ]
 
 vif = [ '' ]
 
@@ -167,7 +173,7 @@ disk = [ 'phy:sda%d,sda1,w' % (7+vmid),
 #hostname= "vm%d" % vmid
 
 # Set root device.
-root = "/dev/sda1 ro"
+root = "/dev/sda1"
 
 # Root device for nfs.
 #root = "/dev/nfs"
@@ -176,8 +182,8 @@ root = "/dev/sda1 ro"
 # Root directory on the nfs server.
 #nfs_root   = '/full/path/to/root/directory'
 
-# Sets runlevel 4 and the device for /usr.
-extra = "4 VMID=%d usr=/dev/sda6" % vmid
+# Sets the device for /usr.
+extra = "VMID=%d usr=/dev/sda6" % vmid
 
 #----------------------------------------------------------------------------
 # Configure the behaviour when a domain exits.  There are three 'reasons'
Index: xen-4.1.4-testing/tools/examples/xmexample3
===================================================================
--- xen-4.1.4-testing.orig/tools/examples/xmexample3
+++ xen-4.1.4-testing/tools/examples/xmexample3
@@ -35,11 +35,17 @@ xm_vars.var('vmid',
 xm_vars.check()
 
 #----------------------------------------------------------------------------
-# Kernel image file.
-kernel = "/path/to/domU/kernel"
+# Kernel image file and (optional) ramdisk (initrd).
+kernel = "/boot/vmlinuz-xen"
+ramdisk = "/boot/initrd-xen"
 
-# Optional ramdisk.
-#ramdisk = "/boot/initrd.gz"
+# Or use a bootloader instead of kernel/ramdisk to get the kernel from domU FS
+# domUloader bootloader example:
+#bootloader = "/usr/lib/xen/boot/domUloader.py"
+#bootentry = "hda2:/vmlinuz-xen,/initrd-xen"
+# pygrub bootloader example:
+#bootloader="/usr/bin/pygrub"
+#bootargs=""
 
 # The domain build function. Default is 'linux'.
 #builder='linux'
Index: xen-4.1.4-testing/tools/examples/xmexample.hvm
===================================================================
--- xen-4.1.4-testing.orig/tools/examples/xmexample.hvm
+++ xen-4.1.4-testing/tools/examples/xmexample.hvm
@@ -64,11 +64,26 @@ name = "ExampleHVMDomain"
 #cpus = "0-3,5,^1" # all vcpus run on cpus 0,2,3,5
 #cpus = ["2", "3"] # VCPU0 runs on CPU2, VCPU1 runs on CPU3
 
-# Optionally define mac and/or bridge for the network interfaces.
-# Random MACs are assigned if not given.
-#vif = [ 'type=ioemu, mac=00:16:3e:00:00:11, bridge=xenbr0, model=ne2k_pci' ]
-# type=ioemu specify the NIC is an ioemu device not netfront
-vif = [ 'type=ioemu, bridge=xenbr0' ]
+#----------------------------------------------------------------------------
+# Define network interfaces.
+
+# By default, no network interfaces are configured.  You may have one created
+# with sensible defaults using an empty vif clause:
+#
+# vif = [ '' ]
+#
+# or optionally override backend, bridge, ip, mac, script, type, model,
+# or vifname.
+#
+# An emulated RealTek 8139 network interface can be configured with:
+#
+# vif = [ 'mac=00:16:3e:00:00:11, type=ioemu, model=rtl8139, bridge=br0' ]
+#
+# A para-virtual network interface can be configured with:
+#
+# vif = [ 'mac=00:16:3e:00:00:11, type=netfront, bridge=br0' ]
+#
+vif = [ '' ]
 
 #----------------------------------------------------------------------------
 # Define the disk devices you want the domain to have access to, and
@@ -78,7 +93,7 @@ vif = [ 'type=ioemu, bridge=xenbr0' ]
 # and MODE is r for read-only, w for read-write.
 
 #disk = [ 'phy:hda1,hda1,r' ]
-disk = [ 'file:/var/images/min-el3-i386.img,hda,w', ',hdc:cdrom,r' ]
+disk = [ 'file:/var/lib/xen/images/disk.img,ioemu:hda,w', ',hdc:cdrom,r' ]
 
 #----------------------------------------------------------------------------
 # Configure the behaviour when a domain exits.  There are three 'reasons'
Index: xen-4.1.4-testing/docs/man/xmdomain.cfg.pod.5
===================================================================
--- xen-4.1.4-testing.orig/docs/man/xmdomain.cfg.pod.5
+++ xen-4.1.4-testing/docs/man/xmdomain.cfg.pod.5
@@ -38,13 +38,13 @@ file.
 
 The kernel image for the domain.  The format of the parameter is the
 fully qualified path to the kernel image file,
-i.e. I</boot/vmlinuz-2.6.12-xenU>.
+i.e. I</boot/vmlinuz-xen>.
 
 
 =item B<ramdisk>
 
 The initial ramdisk for the domain.  The format of the parameter is
-the fully qualified path to the initrd, i.e. I</boot/initrd.gz>.  On
+the fully qualified path to the initrd, i.e. I</boot/initrd-xen>.  On
 many Linux distros you will not need a ramdisk if using the default
 xen kernel.
 
@@ -321,14 +321,14 @@ configured.  They should not be consider
 
 =item I<A Loopback File as Root>
 
-    kernel = "/boot/vmlinuz-2.6-xenU"
+    kernel = "/boot/vmlinuz-xen"
     memory = 128
     name = "MyLinux"      
-    root = "/dev/hda1 ro"
-    disk = [ "file:/var/xen/mylinux.img,hda1,w" ]
+    root = "/dev/hda1"
+    disk = [ "file:/var/lib/xen/images/MyLinux/hda1,hda1,w" ]
 
 This creates a domain called MyLinux with 128 MB of memory using a
-default xen kernel, and the file /var/xen/mylinux.img loopback mounted
+default xen kernel, and the file hda1 loopback mounted
 at hda1, which is the root filesystem.
 
 =item I<NFS Root>
Index: xen-4.1.4-testing/docs/man/xm.pod.1
===================================================================
--- xen-4.1.4-testing.orig/docs/man/xm.pod.1
+++ xen-4.1.4-testing/docs/man/xm.pod.1
@@ -161,8 +161,8 @@ soon as it is run.
 
 =item I<without config file>
  
-  xm create /dev/null ramdisk=initrd.img \
-     kernel=/boot/vmlinuz-2.6.12.6-xenU \
+  xm create /dev/null ramdisk=initrd-xen \
+     kernel=/boot/vmlinuz-xen \
      name=ramdisk vif='' vcpus=1 \
      memory=64 root=/dev/ram0
 
Index: xen-4.1.4-testing/tools/examples/xmexample.hvm-stubdom
===================================================================
--- xen-4.1.4-testing.orig/tools/examples/xmexample.hvm-stubdom
+++ xen-4.1.4-testing/tools/examples/xmexample.hvm-stubdom
@@ -55,11 +55,26 @@ name = "xmexample.hvm"
 #cpus = "0-3,5,^1" # all vcpus run on cpus 0,2,3,5
 #cpus = ["2", "3"] # VCPU0 runs on CPU2, VCPU1 runs on CPU3
 
-# Optionally define mac and/or bridge for the network interfaces.
-# Random MACs are assigned if not given.
-#vif = [ 'type=ioemu, mac=00:16:3e:00:00:11, bridge=xenbr0, model=ne2k_pci' ]
-# type=ioemu specify the NIC is an ioemu device not netfront
-vif = [ 'type=ioemu, bridge=xenbr0' ]
+#----------------------------------------------------------------------------
+# Define network interfaces.
+
+# By default, no network interfaces are configured.  You may have one created
+# with sensible defaults using an empty vif clause:
+#
+# vif = [ '' ]
+#
+# or optionally override backend, bridge, ip, mac, script, type, model,
+# or vifname.
+#
+# An emulated RealTek 8139 network interface can be configured with:
+#
+# vif = [ 'mac=00:16:3e:00:00:11, type=ioemu, model=rtl8139, bridge=br0' ]
+#
+# A para-virtual network interface can be configured with:
+#
+# vif = [ 'mac=00:16:3e:00:00:11, type=netfront, bridge=br0' ]
+#
+vif = [ '' ]
 
 #----------------------------------------------------------------------------
 # Define the disk devices you want the domain to have access to, and
Index: xen-4.1.4-testing/tools/examples/xmexample.pv-grub
===================================================================
--- xen-4.1.4-testing.orig/tools/examples/xmexample.pv-grub
+++ xen-4.1.4-testing/tools/examples/xmexample.pv-grub
@@ -53,11 +53,11 @@ name = "ExampleDomain"
 #
 # or optionally override backend, bridge, ip, mac, script, type, or vifname:
 #
-# vif = [ 'mac=00:16:3e:00:00:11, bridge=xenbr0' ]
+# vif = [ 'mac=00:16:3e:00:00:11, bridge=br0' ]
 #
 # or more than one interface may be configured:
 #
-# vif = [ '', 'bridge=xenbr1' ]
+# vif = [ '', 'bridge=br1' ]
 
 vif = [ '' ]
 
Index: xen-4.1.4-testing/tools/examples/xmexample.vti
===================================================================
--- xen-4.1.4-testing.orig/tools/examples/xmexample.vti
+++ xen-4.1.4-testing/tools/examples/xmexample.vti
@@ -40,11 +40,26 @@ name = "ExampleVTIDomain"
 # In Windows OS, smaller size shows better performance.
 #vhpt = 23
 
-# Optionally define mac and/or bridge for the network interfaces.
-# Random MACs are assigned if not given.
-#vif = [ 'type=ioemu, mac=00:16:3e:00:00:11, bridge=xenbr0, model=ne2k_pci' ]
-# type=ioemu specify the NIC is an ioemu device not netfront
-vif = [ 'type=ioemu, bridge=xenbr0' ]
+#----------------------------------------------------------------------------
+# Define network interfaces.
+
+# By default, no network interfaces are configured.  You may have one created
+# with sensible defaults using an empty vif clause:
+#
+# vif = [ '' ]
+#
+# or optionally override backend, bridge, ip, mac, script, type, model,
+# or vifname.
+#
+# An emulated RealTek 8139 network interface can be configured with:
+#
+# vif = [ 'mac=00:16:3e:00:00:11, type=ioemu, model=rtl8139, bridge=br0' ]
+#
+# A para-virtual network interface can be configured with:
+#
+# vif = [ 'mac=00:16:3e:00:00:11, type=netfront, bridge=br0' ]
+#
+vif = [ '' ]
 
 #----------------------------------------------------------------------------
 # Define the disk devices you want the domain to have access to, and